#include p16f628.inc

;      :
;------------------
TMR1L_1  equ 020h	;   TMR1,
TMR1L_2  equ 021h	;  .
TMR1L_3  equ 022h	;  
TMR1L_4  equ 023h	;  (1-16).
TMR1L_5  equ 024h	
TMR1L_6  equ 025h	
TMR1L_7  equ 026h	
TMR1L_8  equ 027h	
TMR1L_9  equ 028h	
TMR1L_10 equ 029h	
TMR1L_11 equ 02Ah
TMR1L_12 equ 02Bh
TMR1L_13 equ 02Ch
TMR1L_14 equ 02Dh
TMR1L_15 equ 02Eh
TMR1L_16 equ 02Fh

TMR1H_1  equ 030h	;   TMR1,
TMR1H_2  equ 031h	;  .
TMR1H_3  equ 032h	;  
TMR1H_4  equ 033h	;  (1-16).
TMR1H_5  equ 034h
TMR1H_6  equ 035h
TMR1H_7  equ 036h
TMR1H_8  equ 037h
TMR1H_9  equ 038h
TMR1H_10 equ 039h
TMR1H_11 equ 03Ah
TMR1H_12 equ 03Bh
TMR1H_13 equ 03Ch
TMR1H_14 equ 03Dh
TMR1H_15 equ 03Eh
TMR1H_16 equ 03Fh
;------------------------
N_LED_A_1  equ 040h	;      11 . .
N_LED_A_2  equ 041h	;       " ":
N_LED_A_3  equ 042h	;1 -     ,
N_LED_A_4  equ 043h	;2 -     ,
N_LED_A_5  equ 044h	;3 - -
N_LED_A_6  equ 045h	
N_LED_A_7  equ 046h	
N_LED_A_8  equ 047h	
N_LED_A_9  equ 048h	
N_LED_A_10 equ 049h	
N_LED_A_11 equ 04Ah

N_LED_B_1  equ 050h	;    B  11 . .
N_LED_B_2  equ 051h	;       " ":
N_LED_B_3  equ 052h	;1 -     ,
N_LED_B_4  equ 053h	;2 -     ,
N_LED_B_5  equ 054h	;3 - -
N_LED_B_6  equ 055h	
N_LED_B_7  equ 056h	
N_LED_B_8  equ 057h	
N_LED_B_9  equ 058h	
N_LED_B_10 equ 059h	
N_LED_B_11 equ 05Ah
;------------------------

CHASTOTA_L	equ	07Fh	;   TMR1.    .
CHASTOTA_H	equ	07Eh	;   TMR1.    .

CHASTOTA	equ	07Dh	;    .
;".0" -  1, ".15" - 16.      
;   TMR1 (TMR1L_1 - 020h, TMR1H_1 - 030h)     
;   .

FLAGS		equ	07Ch	; .
; <0>  ("0")   ("1")      .
; <7> -    .
;"0" -   , "1" -  .


TEMP		equ	07Bh	;.     .
TEMP1		equ	07Ah	;.     .

EFFEKT		equ	079h	;    .   
				; ,     .

N_LED		equ	078h	;       .
				;   ,   
				;   :
				;N_LED+0x40h     N_LED+0x50h   .

delay		equ	077h	;.     .
;------------------------

;    :

INIT_OPTION	equ	b'00000000'	;TMR0  ( 1).
INIT_PIE1	equ	b'00000001'	;    TMR1 ( 1).
INIT_T1CON	equ	b'00000001'	;TMR1    (clk=32) ( 0).
INIT_INTCON	equ	b'11000000'	;   ( 7)
					;   TMR1 ( 6)	( 0).

;----------------------------------------------------------
; 
		goto RUN
;-------------------------------------------------------
int_point	org	0x004		; 

;		clrf	T1CON		;  TMR1.
;		movwf	W_Temp		;   W  
;		swapf	STATUS,0	;STATUS 
;		movwf	STATUS_Temp	;

;		bcf	PIR1,0		;   
;		bsf	FLAFGS,0	; - .

;		swapf STATUS_Temp,0	;  
;		movwf STATUS		; W  STATUS
;		swapf W_Temp,1		;
;		swapf W_Temp,0		;

;		movf	CHASTOTA_H,w	;  TMR1.
;		movwf	TMR1H
;		movf	CHASTOTA_L,w	;  TMR1.
;		movwf	TMR1L

		return		;  

;----------------------------------------------------------		 
;      TMR1

Data_TMR1
		movlw	.224		; 1.
		movwf	TMR1H_1
		movlw	.192+.25
		movwf	TMR1L_1

		movlw	.240		; 2.
		movwf	TMR1H_2
		movlw	.96+.25
		movwf	TMR1L_2

		movlw	.245		; 3.
		movwf	TMR1H_3
		movlw	.149+.25
		movwf	TMR1L_3

		movlw	.248		; 4.
		movwf	TMR1H_4
		movlw	.48+.25
		movwf	TMR1L_4

		movlw	.249		; 5.
		movwf	TMR1H_5
		movlw	.192+.25
		movwf	TMR1L_5

		movlw	.250		; 6.
		movwf	TMR1H_6
		movlw	.203+.25
		movwf	TMR1L_6

		movlw	.251		; 7.
		movwf	TMR1H_7
		movlw	.137+.25
		movwf	TMR1L_7

		movlw	.252		; 8.
		movwf	TMR1H_8
		movlw	.24+.25
		movwf	TMR1L_8

		movlw	.252		; 9.
		movwf	TMR1H_9
		movlw	.135+.25
		movwf	TMR1L_9

		movlw	.252		; 10.
		movwf	TMR1H_10
		movlw	.224+.25
		movwf	TMR1L_10

		movlw	.253		; 11.
		movwf	TMR1H_11
		movlw	.41+.25
		movwf	TMR1L_11

		movlw	.253		; 12.
		movwf	TMR1H_12
		movlw	.101+.25
		movwf	TMR1L_12

		movlw	.253		; 13.
		movwf	TMR1H_13
		movlw	.153+.25
		movwf	TMR1L_13

		movlw	.253		; 14.
		movwf	TMR1H_14
		movlw	.197+.25
		movwf	TMR1L_14

		movlw	.253+.1		; 15.
		movwf	TMR1H_15
		movlw	.235-.230
		movwf	TMR1L_15

		movlw	.254		; 16.
		movwf	TMR1H_16
		movlw	.12+.25
		movwf	TMR1L_16

		movlw	.0
		movwf	EFFEKT		;    ().
		movwf	CHASTOTA		;   - 1.
		movwf	FLAGS		;  

		return
;---------------------------------------------------------
;     

NEW_F
		movf	CHASTOTA,w
		addlw	020h		;    ,
		movwf	FSR		;   . 
		movf	INDF,w		;   
		movwf	CHASTOTA_L	;      .
		movf	CHASTOTA,w
		addlw	030h		;    ,
		movwf	FSR		;   . 
		movf	INDF,w		;   
		movwf	CHASTOTA_H	;      .

		return
;----------------------------------------------------------
;

Init
		clrf	PORTA		;   ,   
		clrf	PORTB		;    .

		movlw	B'00000111'	; ,   PORT 
		movwf	CMCON		;   /.

		bsf	STATUS,RP0
		movlw	b'11100000'	;RA0-RA4 - , RA5-RA7 - .
		movwf	TRISA^80h	;RA0-RA2 - , RA3 - , RA4 - ,
					;RA5-RA7 - .
		clrf	TRISB^80h	;RB0-RB7 - .
		movlw	INIT_OPTION
		movwf	OPTION_REG^80h
		movlw	INIT_PIE1	;    TMR1.
		movwf	PIE1^80h
		bcf	PCON^80h,OSCF	;    4   32.
;		bcf	STATUS,RP0
		clrf	STATUS

		return
;---------------------------------------------------------------------

RUN
		call	Data_TMR1	;      TMR1.
		call	Init		;.

;----------------------------------------------------------------------
; 

NEW_CONST
		call	NEW_F		;     .
		movf	CHASTOTA_H,w	;  TMR1.
		movwf	TMR1H
		movf	CHASTOTA_L,w	;  TMR1.
		movwf	TMR1L

;----------------------------------------------------------------------
;         .

RUN_EFFEKT

;----------------------------------
;       

		movf	EFFEKT,w	; 
		addwf	PCL,F		; 10  
		goto	EFFEKT_1	;   ( - ).
		goto	EFFEKT_2	;   ( - ).
		goto	EFFEKT_3	;" " (  ).
		goto	EFFEKT_4	;" " (  ).
		goto	EFFEKT_5	;" " (-). 
		goto	EFFEKT_6	; 
		goto	EFFEKT_7	; 
		goto	EFFEKT_8	; 
		goto	EFFEKT_9	; 
		goto	EFFEKT_10	; 
;********************************** 
;        
;  ( - )

EFFEKT_1
		call 	LIGHT_1		;  1- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_1		movlw	b'00000111'	;      
		movwf	PORTA		;   .
		movlw	b'11111111'
		movwf	PORTB

		return

;**********************************
;        
;  ( - )

EFFEKT_2
		call 	LIGHT_2		;  2- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_2		clrf	PORTA		;    
		clrf	PORTB		;   .

		return

;**********************************
;      " "
;	(  )

EFFEKT_3
		call 	LIGHT_3		;  3- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_3		btfss	FLAGS,0	;       .
		call	TABLE_3	; ,  .
		incf	N_LED,w	; ,   1  .
		sublw	.11	;   .
		btfsc	STATUS,2;,       11?
		goto	L3_1	; ,    .
		incf	N_LED,f	;   -     .
		goto	L3_2
L3_1		clrf	N_LED	; .
L3_2		call	OUT_PORT

		return
;------------------------------
OUT_PORT	movf	N_LED,w	;   .
		addlw	040h	;      .
		movwf	FSR	;   . 
		movf	INDF,w	;   
		movwf	PORTA	;      ,   .
		movf	N_LED,w	;   .
		addlw	050h	;      .
		movwf	FSR	;   . 
		movf	INDF,w	;   
		movwf	PORTB	;      ,   .

		return
;------------------------------------------------------------------
;      
;       " ":
;1 -     ,
;2 -     ,
;3 - -
;   "0" -  ,    "1" -  .

TABLE_3
		movlw	b'00000000'	;      " ".
		movwf	N_LED_A_1
		movlw	b'00000001'
		movwf	N_LED_B_1

		movlw	b'00000000'
		movwf	N_LED_A_2
		movlw	b'00000010'
		movwf	N_LED_B_2

		movlw	b'00000000'
		movwf	N_LED_A_3
		movlw	b'00000100'
		movwf	N_LED_B_3

		movlw	b'00000000'
		movwf	N_LED_A_4
		movlw	b'00001000'
		movwf	N_LED_B_4

		movlw	b'00000000'
		movwf	N_LED_A_5
		movlw	b'00010000'
		movwf	N_LED_B_5

		movlw	b'00000000'
		movwf	N_LED_A_6
		movlw	b'00100000'
		movwf	N_LED_B_6

		movlw	b'00000000'
		movwf	N_LED_A_7
		movlw	b'01000000'
		movwf	N_LED_B_7

		movlw	b'00000000'
		movwf	N_LED_A_8
		movlw	b'10000000'
		movwf	N_LED_B_8

		movlw	b'00000001'
		movwf	N_LED_A_9
		movlw	b'00000000'
		movwf	N_LED_B_9

		movlw	b'00000010'
		movwf	N_LED_A_10
		movlw	b'00000000'
		movwf	N_LED_B_10

		movlw	b'00000100'	; (11-)   
		movwf	N_LED_A_11	;  " ".
		movlw	b'00000000'
		movwf	N_LED_B_11

		movlw	.0		;
		movwf	N_LED		;    .
		bsf	FLAGS,0		;  .
					;     .
		return

;**********************************
;      " "
;	(  )

EFFEKT_4
		call 	LIGHT_4		;  4- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_4		btfss	FLAGS,0	;       .
		call	TABLE_3	; ,  .
		decf	N_LED,w	; ,   1  .
		sublw	.255	;   .
		btfsc	STATUS,2;,       0?
		goto	L4_1	; ,    .
		decf	N_LED,f	;   -     .
		goto	L4_2
L4_1		movlw	.10	; .
		movwf	N_LED
L4_2		call	OUT_PORT

		return

;**********************************
;	" "
;	 (-).

EFFEKT_5
		call 	LIGHT_5		;  5- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_5		btfss	FLAGS,0	;       .
		call	TABLE_3	; ,  .

		btfsc	FLAGS,7	;    .
		goto	BACK	;  -    .

	; .

FORwARD		nop
		incf	N_LED,w	;  -  .   .
		sublw	.11	;   .
		btfsc	STATUS,2;,       11?
		goto	L5_1	; ,    .
		incf	N_LED,f	;   -     .
		goto	L5_3
L5_1		bsf	FLAGS,7	;

	; .

BACK		decf	N_LED,w	;  1  .
		sublw	.255	;   .
		btfsc	STATUS,2;,       0?
		goto	L5_2	; ,    .
		decf	N_LED,f	;   -     .
		goto	L5_3
L5_2		bcf	FLAGS,7	; .
		goto	FORwARD

L5_3		call	OUT_PORT

		return

;**********************************
;        
;  ( - )

EFFEKT_6
		call 	LIGHT_6		;  6- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_6		clrf	PORTA		;    
		clrf	PORTB		;   .

		return

;**********************************
;        
;  ( - )

EFFEKT_7
		call 	LIGHT_7		;  7- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_7		clrf	PORTA		;    
		clrf	PORTB		;   .

		return

;**********************************
;        
;  ( - )

EFFEKT_8
		call 	LIGHT_8		;  8- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_8		clrf	PORTA		;    
		clrf	PORTB		;   .

		return

;**********************************
;        
;  ( - )

EFFEKT_9
		call 	LIGHT_9		;  9- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_9		clrf	PORTA		;    
		clrf	PORTB		;   .

		return

;**********************************
;        
;  ( - )

EFFEKT_10
		call 	LIGHT_10	;  10- .
		goto	Interrupt	;   .
;------------------------------
LIGHT_10	clrf	PORTA		;    
		clrf	PORTB		;   .

		return

;**********************************

;---------------------------------------------------------------------
; 

Interrupt
		bcf	PIR1,0		;   
		movlw	INIT_INTCON	;   ( 7).
		movwf	INTCON
		movlw	INIT_T1CON	;TMR1  ( ).
		movwf	T1CON		;    TMR1.

;----------------------------------------------------------------------
; 

TEST_KNOB
		btfsc	PIR1,TMR1IF	;  ?
		goto	NEW_CONST	;  (TMR1IF=1),     .

		movlw	b'11100000'	;.
		andwf	PORTA,w		;    .
		movwf	TEMP		;(   )
		xorlw	b'11100000'	;   ,  ,
		btfsc	STATUS,2	;    ?
		goto	TEST_KNOB	; (PORTA<5,6,7> = 1) -    .
		
		call	delay20		; (PORTA<5or6or7> = 0).  20   .

		movlw	b'11100000'	;   20.  .
		andwf	PORTA,w		;    .
		movwf	TEMP1		;(   )
		xorlw	b'11100000'	;    ,  ,
		btfsc	STATUS,2	;    ?
		goto	TEST_KNOB	; (PORTA<5,6,7> = 1) -    .

		movf	TEMP,w		; (PORTA<5or6or7> = 0).
		xorwf	TEMP1,w		;    ,
		btfss	STATUS,2	;,       .
		goto	TEST_KNOB	; ,      .

		bcf	T1CON,0		;   TMR1. 
		call	ZUMER		;    .

KNOB_5 ;     ( RA5).
		movlw	b'11000000'	;.
		xorwf	TEMP,w		;  .
		btfss	STATUS,2	;,     ?
		goto	KNOB_6		; ,   .
		incf	CHASTOTA,w	; ,    1  
		sublw	.16		; ,
		btfsc	STATUS,2	;      16 (.16).
		goto	KNOB_6		; ,     .
		incf	CHASTOTA,f	;   -     .

KNOB_6 ;     ( RA6).
		movlw	b'10100000'	;.
		xorwf	TEMP,w		;  .
		btfss	STATUS,2	;,     ?
		goto	KNOB_7		; ,   .
		decf	CHASTOTA,w	; ,    1  
		sublw	.255		; ,
		btfsc	STATUS,2	;      1 (.0).
		goto	KNOB_7		; ,     .
		decf	CHASTOTA,f	;   -     .
				
KNOB_7 ;    ( RA7).
		movlw	b'01100000'	;.
		xorwf	TEMP,w		;  .
		btfss	STATUS,2	;,    ?
		goto	KNOB_n		; ,    ( ).
		bcf	FLAGS,0		; ,      ,
		incf	EFFEKT,w	;   1   .
		sublw	.11		;,
		btfsc	STATUS,2	;     (.10).
		goto	n		; ,    .
		incf	EFFEKT,f	;   -     .
		goto	KNOB_n
n		clrf	EFFEKT		;  .

KNOB_n	;    (  ).

;------------------------------------------------------------
; "" .   ,  ,    .
; ,         .

m		movlw	b'11100000'	;.
		andwf	PORTA,w		;    .
		xorwf	TEMP,w		;     ,
		btfsc	STATUS,2	;   ?
		goto	m		;  - ,   .

		goto	NEW_CONST	;,  .   .
					;        .

;*************************************************************
;delay = 160 machine cycles (20ms)
delay20
		movlw	 .53
		movwf	 delay
wr		decfsz delay,F
		goto	 wr

		return
;-----------------------------------------------------
;    .
ZUMER
		bsf	PORTA,3
		call	delay20
		bcf	PORTA,3

		return
;-----------------------------------------------------

		end

